//: C05:DelayedInstantiation.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Instance členských funkcí šablon tříd nejsou vytvářeny 
// dřív než jsou skutečně potřeba.

class X {
public:
  void f() {}
};

class Y {
public:
  void g() {}
};

template<typename T> class Z {
  T t;
public:
  void a() { t.f(); }
  void b() { t.g(); }
};

int main() {
  Z<X> zx;
  zx.a(); // nevytvoří Z<X>::b()
  Z<Y> zy;
  zy.b(); // nevytvoří Z<Y>::a()
} ///:~
